/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.arrebol.apc.web.beans.admin;

import com.arrebol.apc.controller.GenericController;
import com.arrebol.apc.controller.admin.StatsDepositsController;
import com.arrebol.apc.model.core.User;
import com.arrebol.apc.model.views.StatsDepositsView;
import com.arrebol.apc.web.beans.Datatable;
import com.arrebol.apc.web.beans.GenericBean;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.view.ViewScoped;
import javax.inject.Named;
import org.primefaces.event.ReorderEvent;
import org.primefaces.event.RowEditEvent;

/**
 *
 * @author David Rodriguez
 */
@Named("statsDepositsManager")
@ViewScoped
public class StatsDepositsBean extends GenericBean implements Serializable, Datatable {

    public void searchHistoricalAction() {
        try {
            if (getStarDate().after(getEndDate())) {
                showMessage(FacesMessage.SEVERITY_ERROR, getBundlePropertyFile().getString("generic.start.date"), getBundlePropertyFile().getString("generic.end.date.error"));
            } else {
                setDeposits(fillDatatableDeposits());
                setTotalValue();
            }
        } catch (Exception e) {
        }
    }

    public BigDecimal searchTotalDepositsAction() {
        try {
            if (getStarDate().after(getEndDate())) {
                showMessage(FacesMessage.SEVERITY_ERROR, getBundlePropertyFile().getString("generic.start.date"), getBundlePropertyFile().getString("generic.end.date.error"));
            } else {
                setTotalValue();
            }
        } catch (Exception e) {
        }
        return getTotalDeposits();
    }

    public StatsDepositsController getDepositsCtrl() {
        return depositsCtrl;
    }

    public void setDepositsCtrl(StatsDepositsController depositsCtrl) {
        this.depositsCtrl = depositsCtrl;
    }

    public GenericController getGenericCtrl() {
        return genericCtrl;
    }

    public void setGenericCtrl(GenericController genericCtrl) {
        this.genericCtrl = genericCtrl;
    }

    public List<StatsDepositsView> fillDatatableDeposits() {
        return getDepositsCtrl().fillDepositsDataTable(getStarDate(), getEndDate(), getUserSelectedId());
    }

    public BigDecimal fillTotalDeposits() {
        return getDepositsCtrl().fillTotalDeposits(getStarDate(), getEndDate());
    }

    public List<StatsDepositsView> getDeposits() {
        return deposits;
    }

    public void setDeposits(List<StatsDepositsView> deposits) {
        this.deposits = deposits;
    }

    public StatsDepositsView getSelectedDeposits() {
        return selectedDeposits;
    }

    public void setSelectedDeposits(StatsDepositsView selectedDeposits) {
        this.selectedDeposits = selectedDeposits;
    }

    public BigDecimal getTotalDeposits() {
        return totalDeposits;
    }

    public void setTotalDeposits(BigDecimal totalDeposits) {
        this.totalDeposits = totalDeposits;
    }

    public List<User> getUsers() {
        return genericCtrl.getAllUsersByOffice(getLoggedUser().getOffice().getId());
    }
    
    public String getUserSelectedId() {
        return userSelectedId;
    }

    public void setUserSelectedId(String userSelectedId) {
        this.userSelectedId = userSelectedId;
    }
    
    private StatsDepositsController depositsCtrl;
    private GenericController genericCtrl;
    private List<StatsDepositsView> deposits;
    private StatsDepositsView selectedDeposits;
    private BigDecimal totalDeposits;
    private List<User> users;
    private String userSelectedId;

    @PostConstruct
    public void init() {
        loadBundlePropertyFile();
        initStartAndEndDates(Calendar.DAY_OF_WEEK, 2);

        depositsCtrl = new StatsDepositsController();
        genericCtrl = new GenericController();
        deposits = fillDatatableDeposits();
        setTotalValue();
        users = getUsers();
    }

    @Override
    public void editRow(RowEditEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void onRowCancel(RowEditEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void onRowReorder(ReorderEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void addRow() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void deleteRow() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    private void setTotalValue() {
        if (deposits != null && !deposits.isEmpty()) {
            setTotalDeposits(deposits.stream().map(StatsDepositsView::getTotalDeposits).reduce(BigDecimal::add).get());
        } else {
            setTotalDeposits(BigDecimal.ZERO);
        }
    }
}
